#!/bin/bash

function network()
{
    local timeout=10
    local target=http://minerback.heltec.cn/
    local ret_code=`curl -I -s --connect-timeout ${timeout} ${target} -w %{http_code} | tail -n1`
    if [ "x$ret_code" = "x200" ]; then
        return 1
    else
        return 0
    fi
    return 0
}

network
if [ $? -eq 0 ];then
        echo "can't connect to patch url"
        exit -1
fi


patchUrl="http://minerback.heltec.cn/download/patch/"
patch_index_url=$patchUrl"indoor_hotspot_patch_index"
patch_index="/tmp/indoor_hotspot_patch_index"

cd /root/.func/update

curl -s  -H 'Cache-Control: no-cache' $patch_index_url > $patch_index

ver=$(cat version.txt)
verline=$(cat $patch_index | grep -n $ver | cut -f1 -d:)

if [ "$verline" = "" ]
then
	temp=$(cat version.txt | awk -F'v' '{print $2}' |  awk -F'.' '{print $1}' )
	temp1=$(cat $patch_index | tail -1 | awk -F'v' '{print $2}' |  awk -F'.' '{print $1}')
	if [ $temp -gt $temp1 ]
	then
		echo current version is newer
		exit
	fi
fi
let newline=verline+1
newver=$(cat $patch_index | awk -v line=$newline 'NR==line {print $1}')
checksum=$(cat $patch_index | awk -v line=$newline 'NR==line {print $2}')

if [ "$newver" = "" ];
then echo "patch already on the latest patch version"
     exit 0
fi

rm $newver
wget $patchUrl$newver
echo "find new patch "$newver

cal=$(sha256sum $newver | awk -F ' ' '{print $1}')

if [ "$checksum" != "$cal" ];
then echo "checksum failed"
     exit 0
fi

dir=$(echo $newver | awk -F '.' '{print $1}')
rm -rf $dir
tar -zxvf $newver
$dir/update.sh
sed -i "s/"$ver"/"$newver"/g" version.txt

needreboot=$(cat $dir/update.sh | grep reboot)
rm $newver
rm -rf $dir
if [ "$needreboot" != "" ];then reboot;fi
